const pool = require("../config");

// Get all devices
const getAllDevicesDb = async (searchParams = {}) => {
  let queryParams = [];

  // Pagination
  if (searchParams.limit) {
    const page = Number(searchParams.page ?? 1) - 1;
    queryParams = [Number(searchParams.limit ?? 10), page];
  }

  // Search
  const { whereOrConditions, whereParamOr } = pool.buildStringOrIlike(
    [
      "a.device_name",
      "a.device_code",
      "a.device_location",
      "a.ip_address",
      "b.brand_name",
    ],
    searchParams.criteria,
    queryParams
  );

  queryParams = whereParamOr ? whereParamOr : queryParams;

  // Filter
  const { whereConditions, whereParamAnd } = pool.buildFilterQuery(
    [
      { column: "a.device_code", param: searchParams.code, type: "string" },
      { column: "a.device_location", param: searchParams.location, type: "string" },
      { column: "b.brand_name", param: searchParams.brand, type: "string" },
      { column: "a.is_active", param: searchParams.status, type: "string" },
    ],
    queryParams
  );

  queryParams = whereParamAnd ? whereParamAnd : queryParams;

  const queryText = `
    SELECT 
    COUNT(*) OVER() AS total_data,
    a.*,
    b.brand_name,
    COALESCE(a.device_code, '') + ' - ' + COALESCE(a.device_name, '') AS device_code_name
    FROM m_device a
    LEFT JOIN m_brands b ON a.brand_id = b.brand_id
    WHERE a.deleted_at IS NULL
      ${whereConditions.length > 0 ? `AND ${whereConditions.join(' AND ')}` : ''}
      ${whereOrConditions ? whereOrConditions : ''}
    ORDER BY a.device_id ASC
    ${searchParams.limit ? `OFFSET $2 * $1 ROWS FETCH NEXT $1 ROWS ONLY` : ''}
  `;

  const result = await pool.query(queryText, queryParams);

  const total =
    result?.recordset.length > 0
      ? parseInt(result.recordset[0].total_data, 10)
      : 0;

  return { data: result.recordset, total };
};


const getDeviceByIdDb = async (id) => {
  const queryText = `
    SELECT 
    a.*,
    b.brand_name,
    COALESCE(a.device_code, '') + ' - ' + COALESCE(a.device_name, '') AS device_code_name
    FROM m_device a
    LEFT JOIN m_brands b ON a.brand_id = b.brand_id
    WHERE a.device_id = $1 AND a.deleted_at IS NULL
  `;
  const result = await pool.query(queryText, [id]);
  return result.recordset;
};

const createDeviceDb = async (data) => {
  const newCode = await pool.generateKode("DVC", "m_device", "device_code");

  const store = {
    ...data,
    device_code: newCode,
  };

  const { query: queryText, values } = pool.buildDynamicInsert(
    "m_device",
    store
  );
  const result = await pool.query(queryText, values);
  const insertedId = result.recordset[0]?.inserted_id;
  return insertedId ? await getDeviceByIdDb(insertedId) : null;
};

const updateDeviceDb = async (id, data) => {
  const store = {
    ...data,
  };

  // Kondisi WHERE
  const whereData = {
    device_id: id,
  };

  const { query: queryText, values } = pool.buildDynamicUpdate(
    "m_device",
    store,
    whereData
  );
  await pool.query(`${queryText} AND deleted_at IS NULL`, values);
  return getDeviceByIdDb(id);
};

const deleteDeviceDb = async (id, deletedBy) => {
  const queryText = `
    UPDATE m_device
    SET deleted_at = CURRENT_TIMESTAMP, deleted_by = $1
    WHERE device_id = $2 AND deleted_at IS NULL
  `;
  await pool.query(queryText, [deletedBy, id]);
  return true;
};

module.exports = {
  getAllDevicesDb,
  getDeviceByIdDb,
  createDeviceDb,
  updateDeviceDb,
  deleteDeviceDb,
};
